; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : ToolBox Manager
; Nom du fichier : ToolBox Manager.pb
; Version du fichier : 1.0.3
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : Guimauve
; Courriel : gsaumure79@videotron.ca
; Date : 09-02-2012
; Mise  jour : 22-02-2012
; Code PureBasic : 4.61
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; ToolBox Manager Paramtres de lancement en fonction des modes
; 
; Mode Compile : (OK)
; Paramtres  passer : "COMPILE" "%COMPILEFILE"
; Dclancheur : Avant Compiler/Excuter
; Cocher : Attendre la fin du programme
; Cocher : Cacher l'outil du menu principal
; 
; Mode Cration d'un Excutable : (OK)
; Paramtres  passer : "COMPILE" "%COMPILEFILE"
; Dclancheur : Avant de crer un excutable
; Cocher : Attendre la fin du programme
; Cocher : Cacher l'outil du menu principal
; 
; Mode Preference : (OK)
; Paramtres  passer : "PREFS"
; Dclancheur : Menu ou raccourci
;
; Mode Insert : (OK)
; Paramtres  passer : "INSERT" "%FILE" "%CURSOR"
; Dclancheur : "Shift" + "F9"
; Options : Attendre la fin du programme
;           Recharger le code source  la fin du 
;           programme, dans l'onglet courant.
; 
; Mode Ouverture : (OK)
; Paramtres  passer : "OPEN"
; Dclancheur : "Shift" + "F10"
; 
; Mode Chargement : (OK)
; Paramtres  passer : "LOAD" "%FILE" "%CURSOR"
; Dclancheur : "Shift" + "F11"
; 
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

IncludeFile "ToolBox Manager - Constants.pb"

IncludeFile "ToolBox Manager - GadgetGroup.pb"
IncludeFile "ToolBox Manager - Window.pb"
IncludeFile "ToolBox Manager - Language.pb"
IncludeFile "ToolBox Manager - ToolBoxEntry.pb"
IncludeFile "ToolBox Manager - ToolBox.pb"

IncludeFile "ToolBox Manager - ToolBoxManager.pb"

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Routine d'initialisation du programme <<<<<

InitializeToolBoxManager(ToolBoxManager.ToolBoxManager)

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Ouverture de la fentre principale <<<<<

OpenToolBoxManagerWindow(ToolBoxManager)

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Gestion des vnements <<<<<

ToolBoxManagerEventManager(ToolBoxManager)

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 4.61 Beta 1 (Linux - x64)
; CursorPosition = 13
; EnableXP
; Executable = toolbox_manager
; CommandLine = "OPEN"
; CompileSourceDirectory