; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Type V3.130.630
; Nom du projet : Mesh Editor
; Fichier : Mesh Editor - Window.pb
; Version du fichier : 1.2.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : Guimauve
; Courriel : gsaumure79@videotron.ca
; Date : 28-04-2008
; Mise  jour : 09-02-2012
; Cod pour PureBasic V4.60
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Dclaration de la Structure <<<<<

Structure Window

  PosX.w
  PosY.w
  Width.w
  Height.w

EndStructure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Les observateurs <<<<<

Macro GetWindowPosX(WindowA)

  WindowA\PosX

EndMacro

Macro GetWindowPosY(WindowA)

  WindowA\PosY

EndMacro

Macro GetWindowWidth(WindowA)

  WindowA\Width

EndMacro

Macro GetWindowHeight(WindowA)

  WindowA\Height

EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Les mutateurs <<<<<

Macro SetWindowPosX(WindowA, P_PosX)

  GetWindowPosX(WindowA) = P_PosX

EndMacro

Macro SetWindowPosY(WindowA, P_PosY)

  GetWindowPosY(WindowA) = P_PosY

EndMacro

Macro SetWindowWidth(WindowA, P_Width)

  GetWindowWidth(WindowA) = P_Width

EndMacro

Macro SetWindowHeight(WindowA, P_Height)

  GetWindowHeight(WindowA) = P_Height

EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur Update <<<<<

Macro UpdateWindow(WindowA, P_PosX, P_PosY, P_Width, P_Height)

  SetWindowPosX(WindowA, P_PosX)
  SetWindowPosY(WindowA, P_PosY)
  SetWindowWidth(WindowA, P_Width)
  SetWindowHeight(WindowA, P_Height)

EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur Reset <<<<<

Macro ResetWindow(WindowA)
 
  SetWindowPosX(WindowA, 0)
  SetWindowPosY(WindowA, 0)
  SetWindowWidth(WindowA, 0)
  SetWindowHeight(WindowA, 0)
  
  ; ClearStructure(WindowA, Window)

EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Macro de dboguage <<<<<

Macro DebugWindow(WindowA)

  Debug "PosX : " + Str(GetWindowPosX(WindowA))
  Debug "PosY : " + Str(GetWindowPosY(WindowA))
  Debug "Width : " + Str(GetWindowWidth(WindowA))
  Debug "Height : " + Str(GetWindowHeight(WindowA))
  
EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.008 secondes (15250.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Lecture d'un groupe Prfrences <<<<<

Procedure ReadPreferenceWindow(GroupName.s, *WindowA.Window)
  
  PreferenceGroup(GroupName)
  
  SetWindowPosX(*WindowA, ReadPreferenceLong("PosX", GetWindowPosX(*WindowA)))
  SetWindowPosY(*WindowA, ReadPreferenceLong("PosY", GetWindowPosY(*WindowA)))
  SetWindowWidth(*WindowA, ReadPreferenceLong("Width", GetWindowWidth(*WindowA)))
  SetWindowHeight(*WindowA, ReadPreferenceLong("Height", GetWindowHeight(*WindowA)))
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< criture d'un groupe de Prfrences <<<<<

Procedure WritePreferenceWindow(GroupName.s, *WindowA.Window)
  
  PreferenceGroup(GroupName)
  
  WritePreferenceLong("PosX", GetWindowPosX(*WindowA))
  WritePreferenceLong("PosY", GetWindowPosY(*WindowA))
  WritePreferenceLong("Width", GetWindowWidth(*WindowA))
  WritePreferenceLong("Height", GetWindowHeight(*WindowA))
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Initialisation des valeurs par dfaut <<<<<

Procedure InitializeWindow(*WindowA.Window)
  
  SetWindowPosX(*WindowA, 50)
  SetWindowPosY(*WindowA, 50)
  SetWindowWidth(*WindowA, 600) 
  SetWindowHeight(*WindowA, 450)
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur CreateWindow <<<<<

Macro CreateWindow(WinID, WindowA, Flag = #PB_Window_SystemMenu)
  
  OpenWindow(WinID, GetWindowPosX(WindowA), GetWindowPosY(WindowA), GetWindowWidth(WindowA), GetWindowHeight(WindowA), "", Flag)
  
EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur ReshapeWindow <<<<<

Macro ReshapeWindow(WinID, WindowA)
  
  ResizeWindow(WinID, GetWindowPosX(WindowA), GetWindowPosY(WindowA), GetWindowWidth(WindowA), GetWindowHeight(WindowA))
  
EndMacro 

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur GetWindowCurrentPosition <<<<<

Macro GetWindowCurrentPosition(WinID, WindowA)
  
  SetWindowPosX(WindowA, WindowX(WinID))
  SetWindowPosY(WindowA, WindowY(WinID))
  
EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur GetWindowCurrentSize <<<<<

Macro GetWindowCurrentSize(WinID, WindowA)
  
  SetWindowWidth(WindowA, WindowWidth(WinID)) 
  SetWindowHeight(WindowA, WindowHeight(WinID))
  
EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur GetWindowCurrentSize <<<<<

Macro GetWindowCurrentPositionSize(WinID, WindowA)
  
  GetWindowCurrentPosition(WinID, WindowA)
  GetWindowCurrentSize(WinID, WindowA)
  
EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur Verify Window Position <<<<<

Procedure VerifyWindowPosition(*WindowA.Window)
  
  If ExamineDesktops()
    
    If GetWindowPosX(*WindowA) > DesktopWidth(0) Or GetWindowPosX(*WindowA) < 0
      SetWindowPosX(*WindowA, 50)
    EndIf
    
    If GetWindowPosY(*WindowA) > DesktopHeight(0) Or GetWindowPosY(*WindowA) < 0
      SetWindowPosY(*WindowA, 50)
    EndIf
    
    If (GetWindowPosX(*WindowA) + GetWindowWidth(*WindowA)) > DesktopWidth(0)
      SetWindowPosX(*WindowA, GetWindowPosX(*WindowA) - GetWindowWidth(*WindowA))
    EndIf
    
    If (GetWindowPosY(*WindowA) + GetWindowHeight(*WindowA)) > DesktopHeight(0)
      SetWindowPosY(*WindowA, GetWindowPosY(*WindowA) - GetWindowHeight(*WindowA))
    EndIf
    
  Else 
    
    SetWindowPosX(*WindowA, 50)
    SetWindowPosY(*WindowA, 50)
    
  EndIf
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 4.61 Beta 1 (Linux - x64)
; CursorPosition = 175
; FirstLine = 165
; Folding = ----
; CompileSourceDirectory