; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : ToolBox Manager
; Nom du fichier : ToolBox Manager - Constants.pb
; Version du fichier : 1.0.3
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : Guimauve
; Courriel : gsaumure79@videotron.ca
; Date : 09-02-2012
; Mise  jour : 23-02-2012
; Code PureBasic : 4.60
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

#ProgramName = "ToolBox Manager"
#Version = "V1.0.3"

#ToolBoxFile_Keyword_Length = 11
#ToolBoxFile_Keyword_LCase = "toolboxfile"
#ToolBox_Manager_Prefs_FileName = "toolbox_manager.prefs"

Enumeration
  
  ;- ToolBox Manager Running Mode
  
  #ToolBox_Manager_Run_Code_Modify ; The program run hidden on the PB_output_file.pb
  #ToolBox_Manager_Run_Load_Source ; The program load source directly to the IDE
  #ToolBox_Manager_Run_Open_Source ; The program open source directly to the IDE
  #ToolBox_Manager_Run_Preferences ; The program open the Setting window to select the ToolBox Paths
  #ToolBox_Manager_Run_Insert_ToolBoxFile ; The program open the Inserting window to insert the cursor position in the IDE
  
  ;- ToolBox Manager Setting Window
  
  #ToolBox_Manager_Setting_Win  
  
  #Tree_ToolBox_Setting_Path
  #Btn_ToolBox_Setting_Add_Path
  #Btn_ToolBox_Setting_Remove_Path
  #Btn_ToolBox_Setting_Quit
  
  ;- ToolBox Manager Inserting Window
  
  #ToolBox_Manager_Insert_Win
  
  #listView_ToolBox_Insert_Files
  #Btn_ToolBox_Insert_Insert
  #Btn_ToolBox_Insert_Cancel
  
  ;- ToolBox Manager Opening Window
  
  #ToolBox_Manager_Open_Win
  
  #listView_ToolBox_Open_Files
  #Btn_ToolBox_Open_Open
  #Btn_ToolBox_Open_Cancel
  
EndEnumeration

CompilerSelect #PB_Compiler_OS
    
  CompilerCase #PB_OS_Windows 
    #PathSep = "\"

  CompilerCase #PB_OS_Linux
    #PathSep = "/"

  CompilerCase #PB_OS_MacOS
    #PathSep = "/"
    
CompilerEndSelect

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 4.61 Beta 1 (Linux - x64)
; CursorPosition = 9
; Folding = -
; EnableXP
; CompileSourceDirectory