; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Type V3.130.630
; Nom du projet : ToolBox Manager
; Nom du fichier : ToolBox Manager - ToolBox.pb
; Version du fichier : 1.0.2
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : Guimauve
; Courriel : gsaumure79@videotron.ca
; Date : 09-02-2012
; Mise  jour : 22-02-2012
; Cod pour PureBasic V4.60
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Dclaration de la Structure <<<<<

Structure ToolBox
  
  CurrentFile.s
  CurrentLine.l
  CurrentRow.l
  EditorOutputFile.s
  List Paths.ToolBoxEntry()
  Map Files.s()
  
EndStructure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Les observateurs <<<<<

Macro GetToolBoxCurrentFile(ToolBoxA)
  
  ToolBoxA\CurrentFile
  
EndMacro

Macro GetToolBoxCurrentLine(ToolBoxA)
  
  ToolBoxA\CurrentLine
  
EndMacro

Macro GetToolBoxCurrentRow(ToolBoxA)
  
  ToolBoxA\CurrentRow
  
EndMacro

Macro GetToolBoxEditorOutputFile(ToolBoxA)
  
  ToolBoxA\EditorOutputFile
  
EndMacro

Macro GetToolBoxPaths(ToolBoxA)
  
  ToolBoxA\Paths()
  
EndMacro

Macro GetToolBoxFiles(ToolBoxA)
  
  ToolBoxA\Files()
  
EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Les mutateurs <<<<<

Macro SetToolBoxCurrentFile(ToolBoxA, P_CurrentFile)
  
  GetToolBoxCurrentFile(ToolBoxA) = P_CurrentFile
  
EndMacro

Macro SetToolBoxCurrentLine(ToolBoxA, P_CurrentLine)
  
  GetToolBoxCurrentLine(ToolBoxA) = P_CurrentLine
  
EndMacro

Macro SetToolBoxCurrentRow(ToolBoxA, P_CurrentRow)
  
  GetToolBoxCurrentRow(ToolBoxA) = P_CurrentRow
  
EndMacro

Macro SetToolBoxEditorOutputFile(ToolBoxA, P_EditorOutputFile)
  
  GetToolBoxEditorOutputFile(ToolBoxA) = P_EditorOutputFile
  
EndMacro

Macro SetToolBoxPaths(ToolBoxA, P_Paths)
  
  CopyToolBoxEntry(P_Paths, GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro SetToolBoxFiles(ToolBoxA, P_Files)
  
  GetToolBoxFiles(ToolBoxA) = P_Files
  
EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Les macros complmentaires pour les Listes chanes <<<<<

Macro AddToolBoxPathsElement(ToolBoxA)
  
  AddElement(GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro AddToolBoxPathsElementEx(ToolBoxA, P_Name, P_State = #True)
  
  AddElement(GetToolBoxPaths(ToolBoxA))
  UpdateToolBoxEntry(GetToolBoxPaths(ToolBoxA), P_Name, P_State)
  
EndMacro

Macro InsertToolBoxPathsElement(ToolBoxA)
  
  InsertElement(GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro InsertToolBoxPathsElementEx(ToolBoxA, P_Name, P_State = #True)
  
  InsertElement(GetToolBoxPaths(ToolBoxA))
  UpdateToolBoxEntry(GetToolBoxPaths(ToolBoxA), P_Name, P_State)
  
EndMacro

Macro SelectToolBoxPathsElement(ToolBoxA, Position)
  
  SelectElement(GetToolBoxPaths(ToolBoxA), Position)
  
EndMacro

Macro PreviousToolBoxPathsElement(ToolBoxA)
  
  PreviousElement(GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro NextToolBoxPathsElement(ToolBoxA)
  
  NextElement(GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro FirstToolBoxPathsElement(ToolBoxA)
  
  FirstElement(GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro LastToolBoxPathsElement(ToolBoxA)
  
  LastElement(GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro PopListToolBoxPathsPosition(ToolBoxA)
  
  PopListPosition(GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro PushListToolBoxPathsPosition(ToolBoxA)
  
  PushListPosition(GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro DeleteToolBoxPathsElement(ToolBoxA, Flag = 0)
  
  DeleteElement(GetToolBoxPaths(ToolBoxA), Flag)
  
EndMacro

Macro ListToolBoxPathsSize(ToolBoxA)
  
  ListSize(GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro ResetToolBoxPaths(ToolBoxA)
  
  ResetList(GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro ListToolBoxPathsIndex(ToolBoxA)
  
  ListIndex(GetToolBoxPaths(ToolBoxA))
  
EndMacro

Macro ClearToolBoxPaths(ToolBoxA)
  
  ClearList(GetToolBoxPaths(ToolBoxA))
  
EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Les macros complmentaires pour les Maps <<<<<

Macro ReachMapToolBoxFilesElement(ToolBoxA, P_Key)
  
  ToolBoxA\Files(P_Key)
  
EndMacro

Macro AddMapToolBoxFilesElement(ToolBoxA, Key)
  
  AddMapElement(GetToolBoxFiles(ToolBoxA), Key)
  
EndMacro

Macro AddMapToolBoxFilesElementEx(ToolBoxA, Key, P_Element)
  
  AddMapElement(GetToolBoxFiles(ToolBoxA), Key)
  SetToolBoxFiles(ToolBoxA, P_Element)
  
EndMacro

Macro FindMapToolBoxFilesElement(ToolBoxA, Key)
  
  FindMapElement(GetToolBoxFiles(ToolBoxA), Key)
  
EndMacro

Macro DeleteMapToolBoxFilesElement(ToolBoxA, Key)
  
  DeleteMapElement(GetToolBoxFiles(ToolBoxA), Key)
  
EndMacro

Macro MapToolBoxFilesKey(ToolBoxA)
  
  MapKey(GetToolBoxFiles(ToolBoxA))
  
EndMacro

Macro MapToolBoxFilesSize(ToolBoxA)
  
  MapSize(GetToolBoxFiles(ToolBoxA))
  
EndMacro

Macro ResetMapToolBoxFiles(ToolBoxA)
  
  ResetMap(GetToolBoxFiles(ToolBoxA))
  
EndMacro

Macro NextMapToolBoxFilesElement(ToolBoxA)
  
  NextMapElement(GetToolBoxFiles(ToolBoxA))
  
EndMacro

Macro ClearMapToolBoxFiles(ToolBoxA)
  
  ClearMap(GetToolBoxFiles(ToolBoxA))
  
EndMacro

Macro PopMapToolBoxFilesPosition(ToolBoxA)
  
  PopMapPosition(GetToolBoxFiles(ToolBoxA))
  
EndMacro

Macro PushMapToolBoxFilesPosition(ToolBoxA)
  
  PushMapPosition(GetToolBoxFiles(ToolBoxA))
  
EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur Reset <<<<<

Macro ResetToolBox(ToolBoxA)
  
  SetToolBoxCurrentFile(ToolBoxA, "")
  SetToolBoxCurrentLine(ToolBoxA, 0)
  SetToolBoxCurrentRow(ToolBoxA, 0)
  SetToolBoxEditorOutputFile(ToolBoxA, "")
  
  ForEach GetToolBoxPaths(ToolBoxA)
    ResetToolBoxEntry(GetToolBoxPaths(ToolBoxA))
  Next
  
  ClearToolBoxPaths(ToolBoxA)
  
  ForEach GetToolBoxFiles(ToolBoxA)
    SetToolBoxFiles(ToolBoxA, "")
  Next
  
  ClearMapToolBoxFiles(ToolBoxA)
  
  ClearStructure(ToolBoxA, ToolBox)
  InitializeStructure(ToolBoxA, ToolBox)
  
EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Lecture d'un groupe Prfrences <<<<<

Procedure ReadPreferenceToolBox(GroupName.s, *ToolBoxA.ToolBox)
  
  PreferenceGroup(GroupName)
  
  Paths_Max = ReadPreferenceLong("Paths_Max", 0)
  
  For PathsID = 0 To Paths_Max - 1
    AddToolBoxPathsElement(*ToolBoxA)
    ReadPreferenceToolBoxEntry("Paths_" + Str(PathsID), GetToolBoxPaths(*ToolBoxA))
  Next
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< criture d'un groupe de Prfrences <<<<<

Procedure WritePreferenceToolBox(GroupName.s, *ToolBoxA.ToolBox)
  
  PreferenceGroup(GroupName)
  
  WritePreferenceLong("Paths_Max", ListToolBoxPathsSize(*ToolBoxA))
  
  ForEach GetToolBoxPaths(*ToolBoxA)
    WritePreferenceToolBoxEntry("Paths_" + Str(PathsID), GetToolBoxPaths(*ToolBoxA))
    PathsID + 1
  Next
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.009 secondes (33777.78 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Macro de dboguage <<<<<

Macro DebugToolBox(ToolBoxA)
  
  ForEach GetToolBoxPaths(ToolBoxA)
    DebugToolBoxEntry(GetToolBoxPaths(ToolBoxA))
  Next
  
  Debug ""
  
  ForEach GetToolBoxFiles(ToolBoxA)
    Debug "MapMapToolBoxFilesKey : " + MapToolBoxFilesKey(ToolBoxA)
    Debug "File Access Path : " + GetToolBoxFiles(ToolBoxA)
    Debug ""
  Next
  
EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur Recursive_ScanToolBoxDirectories <<<<<

Procedure Recursive_ScanToolBoxDirectories(*ToolBoxA.ToolBox, Path.s)
  
  ToolBox_Path = ExamineDirectory(#PB_Any, Path, "")
  
  If ToolBox_Path <> #Null
    
    While NextDirectoryEntry(ToolBox_Path) <> 0
      
      EntryName.s = DirectoryEntryName(ToolBox_Path)
      
      If Left(EntryName, 1) <> "."
        
        If DirectoryEntryType(ToolBox_Path) = #PB_DirectoryEntry_File
          
          FileName.s = Trim(GetFilePart(EntryName))
          
          If FileName <> "" And (LCase(StringField(FileName, 2, ".")) = "pb" Or LCase(StringField(FileName, 2, ".")) = "pbi")
            AddMapToolBoxFilesElement(*ToolBoxA, FileName)
            SetToolBoxFiles(*ToolBoxA, Path)
          EndIf
          
        Else
          
          Recursive_ScanToolBoxDirectories(*ToolBoxA, Path + EntryName + #PathSep)

        EndIf
        
      EndIf
      
    Wend
    
    FinishDirectory(ToolBox_Path)
    
  EndIf
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur ScanToolBoxDirectories <<<<<

Procedure ScanToolBoxDirectories(*ToolBoxA.ToolBox)
  
  SortStructuredListOfToolBoxEntryByName(GetToolBoxPaths(*ToolBoxA), #PB_Sort_Ascending)
  
  ForEach GetToolBoxPaths(*ToolBoxA)
    If GetToolBoxEntryName(GetToolBoxPaths(*ToolBoxA)) <> "" And GetToolBoxEntryState(GetToolBoxPaths(*ToolBoxA)) = #True
      Recursive_ScanToolBoxDirectories(*ToolBoxA.ToolBox, GetToolBoxEntryName(GetToolBoxPaths(*ToolBoxA)))
    EndIf
  Next
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur AddNewToolBoxPath <<<<<

Procedure AddNewToolBoxPath(*ToolBoxA.ToolBox, *LanguageA.Language)
  
  SortStructuredListOfToolBoxEntryByName(GetToolBoxPaths(*ToolBoxA), #PB_Sort_Ascending)
  
  NewPath.s = Language_PathRequester(*LanguageA)
  
  If NewPath <> ""
    
    ; We perform a Linear search on the Paths entry list
    ; to see if the user are not trying to add the same
    ; path twice. If it's not found we add the NewPath
    ; to the list. Then we re-sort the list.
    
    If LinearSearchLinkedListOfToolBoxEntryByName(GetToolBoxPaths(*ToolBoxA), NewPath) = -1
      AddToolBoxPathsElementEx(*ToolBoxA, NewPath)
      SortStructuredListOfToolBoxEntryByName(GetToolBoxPaths(*ToolBoxA), #PB_Sort_Ascending)
    EndIf

  EndIf
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur DeleteToolBoxPath <<<<<

Procedure DeleteToolBoxPath(*ToolBoxA.ToolBox, GadgetID)
  
  ; We perform a Linear search on the Paths Entry list
  ; to select the element the user want to delete.
  
  If LinearSearchLinkedListOfToolBoxEntryByName(GetToolBoxPaths(*ToolBoxA), GetGadgetItemText(GadgetID, GetGadgetState(GadgetID))) <> -1
    DeleteToolBoxPathsElement(*ToolBoxA)
    SortStructuredListOfToolBoxEntryByName(GetToolBoxPaths(*ToolBoxA), #PB_Sort_Ascending)
  EndIf
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur VerifyToolBoxEntryFile <<<<<

Procedure.b VerifyToolBoxEntryFile(*ToolBoxA.ToolBox, P_EntryFileName.s)
  
  ForEach GetToolBoxFiles(*ToolBoxA)
    
    If MapToolBoxFilesKey(*ToolBoxA) = P_EntryFileName
      ToolBox_Entry_Name_Found.b = #True
      Break
    EndIf
    
  Next
  
  ProcedureReturn ToolBox_Entry_Name_Found
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur Replace_ToolBoxFile_By_IncludeFile <<<<<

Procedure Replace_ToolBoxFile_By_IncludeFile(*ToolBoxA.ToolBox, *LanguageA.Language)
  
  NewList Lines.s()
  
  PB_Output_Source_File = ReadFile(#PB_Any, GetToolBoxEditorOutputFile(*ToolBoxA))
  
  If PB_Output_Source_File <> 0
    
    StringFormat = ReadStringFormat(PB_Output_Source_File)
    
    While Eof(PB_Output_Source_File) = 0
      AddElement(Lines())
      Lines() = ReadString(PB_Output_Source_File, StringFormat)
    Wend
    
    CloseFile(PB_Output_Source_File)
    
  EndIf
  
  PB_Output_Source_File_Mod = CreateFile(#PB_Any, GetToolBoxEditorOutputFile(*ToolBoxA))
  
  If PB_Output_Source_File_Mod  <> 0
    
    ForEach Lines()
      
      If LCase(Left(Lines(), #ToolBoxFile_Keyword_Length)) = #ToolBoxFile_Keyword_LCase
        
        ToolBoxFiles.s = Trim(Right(Lines(), Len(lines()) - #ToolBoxFile_Keyword_Length))
        FieldMax = CountString(ToolBoxFiles, ",") + 1
        
        For FieldID = 1 To FieldMax
          
          Entry.s = RemoveString(Trim(StringField(ToolBoxFiles, FieldID, ",")), Chr(34))
          
          If Entry <> ""
            
            If VerifyToolBoxEntryFile(*ToolBoxA.ToolBox, Entry) = #True
              
              ReachMapToolBoxFilesElement(*ToolBoxA, Entry)
              WriteStringN(PB_Output_Source_File_Mod, "IncludeFile " + Chr(34) + GetToolBoxFiles(*ToolBoxA) + MapToolBoxFilesKey(*ToolBoxA) + Chr(34), StringFormat)
              
            Else
              
              ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ;- File not found error management
              
              ; If the Entry is not found in the ToolBox Entry so we just replace the "ToolBoxFile" 
              ; keyword by "IncludeFile" keyword. Then the compiler will tell the programmer about 
              ; a non existing source file.
              ;
              ; Maybe it's possible to Popup an error message but I don't know if it's possible to
              ; stop the compiling process. Without stopping it, both program (Compiler and ToolBox) 
              ; will tell the user about the same missing file problem.
              
              Language_Error_Message(*LanguageA, #LANUGAGE_ERROR_FILE_NOT_FOUND, Entry)
              
              WriteStringN(PB_Output_Source_File_Mod, "IncludeFile " + Chr(34) + Entry + Chr(34), StringFormat)
              
            EndIf
            
          EndIf
          
        Next
        
      Else
        
        WriteStringN(PB_Output_Source_File_Mod, Lines(), StringFormat)
        
      EndIf
      
      lines() = ""
      
    Next
    
    CloseFile(PB_Output_Source_File_Mod)
    
  EndIf
  
  ClearList(Lines())
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur Load_ToolBoxFile_To_IDE <<<<<

Procedure Load_ToolBoxFile_To_IDE(*ToolBoxA.ToolBox, *LanguageA.Language)
  
  PB_Current_Source_File = ReadFile(#PB_Any, GetToolBoxCurrentFile(*ToolBoxA))
  
  If PB_Current_Source_File <> 0
    
    For LineID = 1 To GetToolBoxCurrentLine(*ToolBoxA) - 1
      ReadString(PB_Current_Source_File)
    Next
    
    ToolBoxFile_To_Load.s = ReadString(PB_Current_Source_File)
    
    CloseFile(PB_Current_Source_File)
    
  EndIf

  ToolBoxFiles.s = RemoveString(Trim(Right(ToolBoxFile_To_Load, Len(ToolBoxFile_To_Load) - #ToolBoxFile_Keyword_Length)), Chr(34))
  FieldMax = CountString(ToolBoxFiles, ",") + 1
  
  For FieldID = 1 To FieldMax
    
    Entry.s = Trim(StringField(ToolBoxFiles, FieldID, ","))
    
    If Entry <> ""
      
      If VerifyToolBoxEntryFile(*ToolBoxA, Entry)
        
        ReachMapToolBoxFilesElement(*ToolBoxA, Entry)
        Buffer.s + Chr(34) + GetToolBoxFiles(*ToolBoxA) + MapToolBoxFilesKey(*ToolBoxA) + Chr(34)
        
        If FieldID < FieldMax
          Buffer + " "
        EndIf
        
      Else
        
        ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ;- File not found error management
        
        ; If the Entry is not found in the ToolBox Entry we just don't add it to the current 
        ; insert. We add to add an error message about a non-exisiting file. This can appen 
        ; when a user write ToolBoxFile "...", "..." manually. 
        
        Language_Error_Message(*LanguageA, #LANUGAGE_ERROR_FILE_NOT_FOUND, Entry)
        
      EndIf
      
    EndIf
    
  Next
  
  If Buffer <> ""
    IDE.s = GetEnvironmentVariable("PB_TOOL_IDE")
    RunProgram(IDE, Buffer, GetPathPart(IDE))
  EndIf
  
EndProcedure 

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur ToolBoxPaths_To_GUI <<<<<

Procedure ToolBoxPaths_To_GUI(*ToolBoxA.ToolBox, GadgetID)
  
  ClearGadgetItems(GadgetID)
  
  ForEach GetToolBoxPaths(*ToolBoxA)
    
    If GetToolBoxEntryName(GetToolBoxPaths(*ToolBoxA)) <> ""
      
      AddGadgetItem(GadgetID, PathID, GetToolBoxEntryName(GetToolBoxPaths(*ToolBoxA)), 0, 0)
      
      If GetToolBoxEntryState(GetToolBoxPaths(*ToolBoxA)) = #True
        SetGadgetItemState(GadgetID, PathID, #PB_Tree_Checked)
      EndIf
      
      PathID + 1
      
    EndIf
    
  Next
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur GUI_To_ToolBoxPaths <<<<<

Procedure GUI_To_ToolBoxPaths(*ToolBoxA.ToolBox, GadgetID)
  
  ForEach GetToolBoxPaths(*ToolBoxA)
    
    If GetToolBoxEntryName(GetToolBoxPaths(*ToolBoxA)) <> ""
      
      If GetGadgetItemState(GadgetID, PathID) & #PB_Tree_Checked
        SetToolBoxEntryState(GetToolBoxPaths(*ToolBoxA), #True)
      Else
        SetToolBoxEntryState(GetToolBoxPaths(*ToolBoxA), #False)
      EndIf
      
      PathID + 1
      
    EndIf
    
  Next
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur ToolBoxFiles_To_GUI <<<<<

Procedure ToolBoxFiles_To_GUI(*ToolBoxA.ToolBox, GadgetID)
  
  NewList FileList.s()
  
  ForEach GetToolBoxFiles(*ToolBoxA)
    AddElement(FileList())
    FileList() = MapToolBoxFilesKey(*ToolBoxA)
  Next
  
  SortList(FileList(), #PB_Sort_Ascending)
  
  ForEach FileList()
    AddGadgetItem(GadgetID, FileID, FileList())
    FileID + 1
  Next
  
  ClearList(FileList())
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur GUI_To_ToolBoxFiles <<<<<

Procedure GUI_To_ToolBoxFiles(*ToolBoxA.ToolBox, GadgetID)
  
  NewList Files.s()
  
  ItemsMax = CountGadgetItems(GadgetID)
  
  For ItemsID = 0 To ItemsMax
    
    If GetGadgetItemState(GadgetID, ItemsID) = 1
      AddElement(Files())
      Files() = GetGadgetItemText(GadgetID, ItemsID)
    EndIf
    
  Next
  
  ForEach Files()
    
    Buffer.s + Chr(34) + Files() + Chr(34)
    
    If ListIndex(Files()) < ListSize(Files()) - 1
      Buffer + ", "
    EndIf
    
    Files() = ""
    
  Next
  
  ClearList(Files())
  
  NewList Lines.s()
  
  PB_Current_Source_File = ReadFile(#PB_Any, GetToolBoxCurrentFile(*ToolBoxA))
  
  If PB_Current_Source_File <> 0
    
    StringFormat = ReadStringFormat(PB_Current_Source_File)
    
    While Eof(PB_Current_Source_File) = 0
      AddElement(Lines())
      Lines() = ReadString(PB_Current_Source_File, StringFormat)
    Wend
    
    CloseFile(PB_Current_Source_File)
    
  EndIf
  
  PB_Current_Source_File_Mod = CreateFile(#PB_Any, GetToolBoxCurrentFile(*ToolBoxA))
  
  If PB_Current_Source_File_Mod  <> 0
    
    ForEach Lines()
      
      If ListIndex(Lines()) <> (GetToolBoxCurrentLine(*ToolBoxA)-1)
        
        ; Were not on the current line so we re-write this line as is.
        WriteStringN(PB_Current_Source_File_Mod, Lines(), StringFormat)
        
      Else
        
        If LCase(Left(Lines(), #ToolBoxFile_Keyword_Length)) = #ToolBoxFile_Keyword_LCase
          
          ; In this case the user want to add more file on the ToolBoxFile previously added.
          WriteStringN(PB_Current_Source_File_Mod, Lines() + ", " + Buffer, StringFormat)
          
        ElseIf GetToolBoxCurrentRow(*ToolBoxA) <= 1 And Lines() = ""
          
          ; In this case the line is empty
          WriteStringN(PB_Current_Source_File_Mod, "ToolBoxFile " + Buffer, StringFormat)
          
        Else
          
          ; In this case the line is not empty so we split this line in two parts using the 
          ; current row then we add our stuff right between them. Tought luck if the user
          ; has make a mistake. He will have to correct the error manually, no "UNDO" 
          ; possible.
          
          FrontPart.s = Left(Lines(), GetToolBoxCurrentRow(*ToolBoxA))
          BackPart.s = Right(Lines(), Len(Lines()) - GetToolBoxCurrentRow(*ToolBoxA))
          WriteStringN(PB_Current_Source_File_Mod, FrontPart + "ToolBoxFile " + Buffer + BackPart)
          
        EndIf
        
      EndIf
      
      Lines() = ""
      
    Next
    
    CloseFile(PB_Current_Source_File_Mod)
    
  EndIf
  
  ClearList(Lines())
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur Open_ToolBoxFile_To_IDE <<<<<

Procedure Open_ToolBoxFile_To_IDE(*ToolBoxA.ToolBox, GadgetID)
  
  ItemsMax = CountGadgetItems(GadgetID)
  
  For ItemsID = 0 To ItemsMax
    
    If GetGadgetItemState(GadgetID, ItemsID) = #True
      
      Entry.s = GetGadgetItemText(GadgetID, ItemsID)
      
      If Entry <> ""
        
        If VerifyToolBoxEntryFile(*ToolBoxA, Entry)
          
          ReachMapToolBoxFilesElement(*ToolBoxA, Entry)
          Buffer.s + Chr(34) + GetToolBoxFiles(*ToolBoxA) + MapToolBoxFilesKey(*ToolBoxA) + Chr(34)
          
          If FieldID < ItemsMax
            Buffer + " "
          EndIf
          
        EndIf
        
      EndIf
    EndIf
    
  Next
  
  If Buffer <> ""
    IDE.s = GetEnvironmentVariable("PB_TOOL_IDE")
    RunProgram(IDE, Buffer, GetPathPart(IDE))
  EndIf
  
EndProcedure 

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 4.61 Beta 1 (Linux - x64)
; CursorPosition = 396
; FirstLine = 346
; Folding = -------8A5
; EnableUnicode
; EnableXP
; CompileSourceDirectory