; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Type V3.130.630
; Nom du projet : ToolBox Manager
; Nom du fichier : ToolBox Manager - ToolBoxManager.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : Guimauve
; Courriel : gsaumure79@videotron.ca
; Date : 09-02-2012
; Mise  jour : 11-02-2012
; Cod pour PureBasic V4.60
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Dclaration de la Structure <<<<<

Structure ToolBoxManager

  PrefFile.s
  SettingWindow.Window
  InsertWindow.Window
  ToolBox.ToolBox
  Language.Language
  RunningMode.b

EndStructure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Les observateurs <<<<<

Macro GetToolBoxManagerPrefFile(ToolBoxManagerA)

  ToolBoxManagerA\PrefFile

EndMacro

Macro GetToolBoxManagerSettingWindow(ToolBoxManagerA)

  ToolBoxManagerA\SettingWindow

EndMacro

Macro GetToolBoxManagerInsertWindow(ToolBoxManagerA)

  ToolBoxManagerA\InsertWindow

EndMacro

Macro GetToolBoxManagerToolBox(ToolBoxManagerA)

  ToolBoxManagerA\ToolBox

EndMacro

Macro GetToolBoxManagerLanguage(ToolBoxManagerA)

  ToolBoxManagerA\Language

EndMacro

Macro GetToolBoxManagerRunningMode(ToolBoxManagerA)

  ToolBoxManagerA\RunningMode

EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Les mutateurs <<<<<

Macro SetToolBoxManagerPrefFile(ToolBoxManagerA, P_PrefFile)

  GetToolBoxManagerPrefFile(ToolBoxManagerA) = P_PrefFile

EndMacro

Macro SetToolBoxManagerSettingWindow(ToolBoxManagerA, P_SettingWindow)

  CopyWindow(P_SettingWindow, GetToolBoxManagerSettingWindow(ToolBoxManagerA))

EndMacro

Macro SetToolBoxManagerInsertWindow(ToolBoxManagerA, P_InsertWindow)

  CopyWindow(P_InsertWindow, GetToolBoxManagerInsertWindow(ToolBoxManagerA))

EndMacro

Macro SetToolBoxManagerToolBox(ToolBoxManagerA, P_ToolBox)

  CopyToolBox(P_ToolBox, GetToolBoxManagerToolBox(ToolBoxManagerA))

EndMacro

Macro SetToolBoxManagerLanguage(ToolBoxManagerA, P_Language)

  CopyLanguage(P_Language, GetToolBoxManagerLanguage(ToolBoxManagerA))

EndMacro

Macro SetToolBoxManagerRunningMode(ToolBoxManagerA, P_RunningMode)

  GetToolBoxManagerRunningMode(ToolBoxManagerA) = P_RunningMode

EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur Reset <<<<<

Macro ResetToolBoxManager(ToolBoxManagerA)
 
  SetToolBoxManagerPrefFile(ToolBoxManagerA, "")
  ResetWindow(GetToolBoxManagerSettingWindow(ToolBoxManagerA))
  ResetWindow(GetToolBoxManagerInsertWindow(ToolBoxManagerA))
  ResetToolBox(GetToolBoxManagerToolBox(ToolBoxManagerA))
  ResetLanguage(GetToolBoxManagerLanguage(ToolBoxManagerA))
  SetToolBoxManagerRunningMode(ToolBoxManagerA, 0)

EndMacro

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.004 secondes (45500.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Ouverture d'un fichier de Prfrences <<<<<

Procedure OpenToolBoxManagerPreferences(*ToolBoxManagerA.ToolBoxManager)

  If OpenPreferences(GetToolBoxManagerPrefFile(*ToolBoxManagerA))
 
    ReadPreferenceWindow("SettingWindow", GetToolBoxManagerSettingWindow(*ToolBoxManagerA))
    ReadPreferenceWindow("InsertWindow", GetToolBoxManagerInsertWindow(*ToolBoxManagerA))
    ReadPreferenceToolBox("ToolBox", GetToolBoxManagerToolBox(*ToolBoxManagerA))

    ClosePreferences()

  EndIf

EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Cration d'un fichier de Prfrences <<<<<

Procedure CreateToolBoxManagerPreferences(*ToolBoxManagerA.ToolBoxManager)

  If CreatePreferences(GetToolBoxManagerPrefFile(*ToolBoxManagerA))
 
    WritePreferenceWindow("SettingWindow", GetToolBoxManagerSettingWindow(*ToolBoxManagerA))
    WritePreferenceWindow("InsertWindow", GetToolBoxManagerInsertWindow(*ToolBoxManagerA))
    WritePreferenceToolBox("ToolBox", GetToolBoxManagerToolBox(*ToolBoxManagerA))

    ClosePreferences()

  EndIf

EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< L'oprateur Initialize <<<<<

Procedure InitializeToolBoxManager(*ToolBoxManagerA.ToolBoxManager)
  
  ;- Traitement des Paramtres de lancement du programme
  
  ParamMax.l = CountProgramParameters()
  
  If ParamMax > 0
    
    Select ProgramParameter(0)
        
      Case "PREFS"
        SetToolBoxManagerRunningMode(*ToolBoxManagerA, #ToolBox_Manager_Run_Preferences)
        
        Case "OPEN"
        SetToolBoxManagerRunningMode(*ToolBoxManagerA, #ToolBox_Manager_Run_Open_Source)
        
      Case "COMPILE"
        SetToolBoxManagerRunningMode(*ToolBoxManagerA, #ToolBox_Manager_Run_Code_Modify)
        SetToolBoxEditorOutputFile(GetToolBoxManagerToolBox(*ToolBoxManagerA), ProgramParameter(1))
        
      Case "LOAD"
        SetToolBoxManagerRunningMode(*ToolBoxManagerA, #ToolBox_Manager_Run_Load_Source)
        SetToolBoxCurrentFile(GetToolBoxManagerToolBox(*ToolBoxManagerA), ProgramParameter(1))
        Position.s = ProgramParameter(2)
        SetToolBoxCurrentLine(GetToolBoxManagerToolBox(*ToolBoxManagerA), Val(StringField(Position, 1,"x")))
        SetToolBoxCurrentRow(GetToolBoxManagerToolBox(*ToolBoxManagerA), Val(StringField(Position, 2,"x")) - 1)

      Case "INSERT"
        SetToolBoxManagerRunningMode(*ToolBoxManagerA, #ToolBox_Manager_Run_Insert_ToolBoxFile)
        SetToolBoxCurrentFile(GetToolBoxManagerToolBox(*ToolBoxManagerA), ProgramParameter(1))
        Position.s = ProgramParameter(2)
        SetToolBoxCurrentLine(GetToolBoxManagerToolBox(*ToolBoxManagerA), Val(StringField(Position, 1,"x")))
        SetToolBoxCurrentRow(GetToolBoxManagerToolBox(*ToolBoxManagerA), Val(StringField(Position, 2,"x")) - 1)
        
      Default 
        ResetToolBoxManager(*ToolBoxManagerA)
        End
        
    EndSelect
    
  EndIf
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows
      SetToolBoxManagerPrefFile(*ToolBoxManagerA, GetEnvironmentVariable("APPDATA") + #PathSep + "Purebasic" + #PathSep + #ToolBox_Manager_Prefs_FileName)
      
    CompilerCase #PB_OS_Linux
      SetToolBoxManagerPrefFile(*ToolBoxManagerA, GetHomeDirectory() + ".purebasic" + #PathSep + #ToolBox_Manager_Prefs_FileName)
      
    CompilerCase #PB_OS_MacOS 
      ;- To be confirmed : The path were the PB IDE save it's preferences files
      ; For the moment it's the same as the linux one's.
      SetToolBoxManagerPrefFile(*ToolBoxManagerA, GetHomeDirectory() + ".purebasic" + #PathSep + #ToolBox_Manager_Prefs_FileName)
      
  CompilerEndSelect
  
  UpdateWindow(GetToolBoxManagerSettingWindow(*ToolBoxManagerA), 50, 50, 460, 300)
  UpdateWindow(GetToolBoxManagerInsertWindow(*ToolBoxManagerA), 50, 50, 315, 400)
  
  InitializeLanguage(GetToolBoxManagerLanguage(*ToolBoxManagerA), "", "language")
  LoadLanguageFile(GetToolBoxManagerLanguage(*ToolBoxManagerA))
  
  If FileSize(GetToolBoxManagerPrefFile(*ToolBoxManagerA)) = -1
    CreateToolBoxManagerPreferences(*ToolBoxManagerA)
  Else
    OpenToolBoxManagerPreferences(*ToolBoxManagerA)
  EndIf
  
  ScanToolBoxDirectories(GetToolBoxManagerToolBox(*ToolBoxManagerA))
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Routine de fermeture du programme <<<<<

Procedure ShutDownToolBoxManager(*ToolBoxManagerA.ToolBoxManager)
  
  Select GetToolBoxManagerRunningMode(*ToolBoxManagerA) 
      
    Case #ToolBox_Manager_Run_Preferences
      
      GetWindowCurrentPositionSize(#ToolBox_Manager_Setting_Win, GetToolBoxManagerSettingWindow(*ToolBoxManagerA))
      CreateToolBoxManagerPreferences(*ToolBoxManagerA)
      CloseWindow(#ToolBox_Manager_Setting_Win)
      
    Case #ToolBox_Manager_Run_Insert_ToolBoxFile
      
      GetWindowCurrentPositionSize(#ToolBox_Manager_Insert_Win, GetToolBoxManagerInsertWindow(*ToolBoxManagerA))
      CreateToolBoxManagerPreferences(*ToolBoxManagerA)
      CloseWindow(#ToolBox_Manager_Insert_Win)
      
  EndSelect 
  
  ResetToolBoxManager(*ToolBoxManagerA)
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Routine de fermeture du programme <<<<<

Procedure ResizeToolBoxManagerWindow(*ToolBoxManagerA.ToolBoxManager)
  
  Select GetToolBoxManagerRunningMode(*ToolBoxManagerA) 
      
    Case #ToolBox_Manager_Run_Preferences
      ResizeGadget(#Tree_ToolBox_Setting_Path, #PB_Ignore, #PB_Ignore, WindowWidth(#ToolBox_Manager_Setting_Win) - 10, WindowHeight(#ToolBox_Manager_Setting_Win) - 45)
      ResizeButtonGroupHorizontal(#Btn_ToolBox_Setting_Add_Path, #Btn_ToolBox_Setting_Quit, WindowWidth(#ToolBox_Manager_Setting_Win) - 160*3 - 15, WindowHeight(#ToolBox_Manager_Setting_Win) - 35, 160, 30)
      
    Case #ToolBox_Manager_Run_Insert_ToolBoxFile
      ResizeGadget(#listView_ToolBox_Insert_Files, #PB_Ignore, #PB_Ignore, WindowWidth(#ToolBox_Manager_Insert_Win) - 10, WindowHeight(#ToolBox_Manager_Insert_Win) - 45) 
      ResizeButtonGroupHorizontal(#Btn_ToolBox_Insert_Insert, #Btn_ToolBox_Insert_Cancel, WindowWidth(#ToolBox_Manager_Insert_Win) - 145*2 - 10, WindowHeight(#ToolBox_Manager_Insert_Win) - 35, 145, 30)
      
    Case #ToolBox_Manager_Run_Open_Source
      ResizeGadget(#listView_ToolBox_Open_Files, #PB_Ignore, #PB_Ignore, WindowWidth(#ToolBox_Manager_Open_Win) - 10, WindowHeight(#ToolBox_Manager_Open_Win) - 45) 
      ResizeButtonGroupHorizontal(#Btn_ToolBox_Open_Open, #Btn_ToolBox_Open_Cancel, WindowWidth(#ToolBox_Manager_Open_Win) - 145*2 - 10, WindowHeight(#ToolBox_Manager_Open_Win) - 35, 145, 30)
      
  EndSelect 
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Ouverture de la fentre principale <<<<<

Procedure OpenToolBoxManagerWindow(*ToolBoxManagerA.ToolBoxManager)
  
  Select GetToolBoxManagerRunningMode(*ToolBoxManagerA)
      
    Case #ToolBox_Manager_Run_Preferences
    
    If CreateWindow(#ToolBox_Manager_Setting_Win, GetToolBoxManagerSettingWindow(*ToolBoxManagerA), #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget)
      
      WindowBounds(#ToolBox_Manager_Setting_Win, 500, 300, #PB_Ignore, #PB_Ignore)  
      ReshapeWindow(#ToolBox_Manager_Setting_Win, GetToolBoxManagerSettingWindow(*ToolBoxManagerA))
    
      TreeGadget(#Tree_ToolBox_Setting_Path, 5, 5, WindowWidth(#ToolBox_Manager_Setting_Win) - 10, WindowHeight(#ToolBox_Manager_Setting_Win) - 45, #PB_Tree_CheckBoxes)    
      ButtonGroupHorizontal(#Btn_ToolBox_Setting_Add_Path, #Btn_ToolBox_Setting_Quit, WindowWidth(#ToolBox_Manager_Setting_Win) - 160*3 - 15, WindowHeight(#ToolBox_Manager_Setting_Win) - 35, 160, 30)
      
      ToolBoxPaths_To_GUI(GetToolBoxManagerToolBox(*ToolBoxManagerA), #Tree_ToolBox_Setting_Path)
      Language_To_GUI(GetToolBoxManagerLanguage(*ToolBoxManagerA), #LANGUAGE_SETTING_WINDOW)

    EndIf 
    
  Case #ToolBox_Manager_Run_Insert_ToolBoxFile
    
    If CreateWindow(#ToolBox_Manager_Insert_Win, GetToolBoxManagerInsertWindow(*ToolBoxManagerA))
      
      WindowBounds(#ToolBox_Manager_Insert_Win, 315, 400, #PB_Ignore, #PB_Ignore)  
      ReshapeWindow(#ToolBox_Manager_Insert_Win, GetToolBoxManagerInsertWindow(*ToolBoxManagerA))
      
      ListViewGadget(#listView_ToolBox_Insert_Files, 5, 5, WindowWidth(#ToolBox_Manager_Insert_Win) - 10, WindowHeight(#ToolBox_Manager_Insert_Win) - 45, #PB_ListView_ClickSelect) 
      ButtonGroupHorizontal(#Btn_ToolBox_Insert_Insert, #Btn_ToolBox_Insert_Cancel, WindowWidth(#ToolBox_Manager_Insert_Win) - 145*2 - 10, WindowHeight(#ToolBox_Manager_Insert_Win) - 35, 145, 30)
      
      ToolBoxFiles_To_GUI(GetToolBoxManagerToolBox(*ToolBoxManagerA), #listView_ToolBox_Insert_Files)
      Language_To_GUI(GetToolBoxManagerLanguage(*ToolBoxManagerA), #LANGUAGE_INSERT_WINDOW)
      
    EndIf
    
  Case #ToolBox_Manager_Run_Open_Source
    
    If CreateWindow(#ToolBox_Manager_Open_Win, GetToolBoxManagerInsertWindow(*ToolBoxManagerA))
      
      WindowBounds(#ToolBox_Manager_Open_Win, 315, 400, #PB_Ignore, #PB_Ignore)  
      ReshapeWindow(#ToolBox_Manager_Open_Win, GetToolBoxManagerInsertWindow(*ToolBoxManagerA))
      
      ListViewGadget(#listView_ToolBox_Open_Files, 5, 5, WindowWidth(#ToolBox_Manager_Open_Win) - 10, WindowHeight(#ToolBox_Manager_Open_Win) - 45, #PB_ListView_ClickSelect) 
      ButtonGroupHorizontal(#Btn_ToolBox_Open_Open, #Btn_ToolBox_Open_Cancel, WindowWidth(#ToolBox_Manager_Open_Win) - 145*2 - 10, WindowHeight(#ToolBox_Manager_Open_Win) - 35, 145, 30)
      
      ToolBoxFiles_To_GUI(GetToolBoxManagerToolBox(*ToolBoxManagerA), #listView_ToolBox_Open_Files)
      Language_To_GUI(GetToolBoxManagerLanguage(*ToolBoxManagerA), #LANGUAGE_OPEN_WINDOW)
      
    EndIf
    
  EndSelect
  
EndProcedure 

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Gestion des vnements <<<<<

Procedure ToolBoxManagerEventManager(*ToolBoxManagerA.ToolBoxManager)
  
  Select GetToolBoxManagerRunningMode(*ToolBoxManagerA)
      
    Case #ToolBox_Manager_Run_Preferences, #ToolBox_Manager_Run_Insert_ToolBoxFile, #ToolBox_Manager_Run_Open_Source
      
      Repeat
        
        EventID = WaitWindowEvent()
        
        Select EventID
            
          Case #PB_Event_Gadget
            
            Select EventGadget()
                
              Case #Btn_ToolBox_Setting_Add_Path
                AddNewToolBoxPath(GetToolBoxManagerToolBox(*ToolBoxManagerA), GetToolBoxManagerLanguage(*ToolBoxManagerA))
                ToolBoxPaths_To_GUI(GetToolBoxManagerToolBox(*ToolBoxManagerA), #Tree_ToolBox_Setting_Path)
                
              Case #Btn_ToolBox_Setting_Remove_Path
                DeleteToolBoxPath(GetToolBoxManagerToolBox(*ToolBoxManagerA), #Tree_ToolBox_Setting_Path)
                ToolBoxPaths_To_GUI(GetToolBoxManagerToolBox(*ToolBoxManagerA), #Tree_ToolBox_Setting_Path)
                
              Case #Btn_ToolBox_Setting_Quit
                GUI_To_ToolBoxPaths(GetToolBoxManagerToolBox(*ToolBoxManagerA), #Tree_ToolBox_Setting_Path)
                ShutDownToolBoxManager(*ToolBoxManagerA)
                EventID = #PB_Event_CloseWindow
                
              Case #Btn_ToolBox_Insert_Insert
                GUI_To_ToolBoxFiles(GetToolBoxManagerToolBox(*ToolBoxManagerA), #listView_ToolBox_Insert_Files)
                ShutDownToolBoxManager(*ToolBoxManagerA)
                EventID = #PB_Event_CloseWindow
                
              Case #Btn_ToolBox_Insert_Cancel
                EventID = #PB_Event_CloseWindow
                ShutDownToolBoxManager(*ToolBoxManagerA)  
                End -1
                
              Case #Btn_ToolBox_Open_Open
                Open_ToolBoxFile_To_IDE(GetToolBoxManagerToolBox(*ToolBoxManagerA), #listView_ToolBox_Open_Files)
                ShutDownToolBoxManager(*ToolBoxManagerA)
                EventID = #PB_Event_CloseWindow
                
              Case #Btn_ToolBox_Open_Cancel
                EventID = #PB_Event_CloseWindow
                ShutDownToolBoxManager(*ToolBoxManagerA)  
                End -1
                
            EndSelect
            
          Case #PB_Event_SizeWindow
            ResizeToolBoxManagerWindow(*ToolBoxManagerA)
            
        EndSelect
        
      Until EventID = #PB_Event_CloseWindow

    Case #ToolBox_Manager_Run_Code_Modify
      Replace_ToolBoxFile_By_IncludeFile(GetToolBoxManagerToolBox(*ToolBoxManagerA), GetToolBoxManagerLanguage(*ToolBoxManagerA))
      
    Case #ToolBox_Manager_Run_Load_Source
      Load_ToolBoxFile_To_IDE(GetToolBoxManagerToolBox(*ToolBoxManagerA), GetToolBoxManagerLanguage(*ToolBoxManagerA))
      
  EndSelect

EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 4.61 Beta 1 (Linux - x64)
; CursorPosition = 281
; FirstLine = 258
; Folding = ---8
; EnableXP
; CompileSourceDirectory